{ lib, ... }:

with builtins;
with lib;

let
  fn = import ./fn.nix { inherit lib; };
  # hostName can be set with -I hostName=$HOSTNAME, defaults to the contents of /secret/hostName
  hostName = let
    hostVal = (tryEval <hostName>).value;
  in fn.ifelse (hostVal != false)
    hostVal
    (fileContents /secret/hostName);
  machinePath = (builtins.toPath ( ./machines + ("/" + hostName)));
  machineConf = machinePath + "/configuration.nix";
  machineOpts = machinePath + "/options.nix";
in {
  imports = [
    machineConf
    machineOpts
    ./config/default.nix
    ./pkgs/nixpkgs.nix
    ./pkgs/systemPackages.nix
    ./services/containers.nix
    ./services/default.nix
  ];
}
